568. Maximum Vacation Days

拈花ヽ惹草 提交于 2020-02-01 09:03:09
LeetCode wants to give one of its best employees the option to travel among N cities to collect algorithm problems. But all work and no play makes Jack a dull boy, you could take vacations in some particular cities and weeks. Your job is to schedule the traveling to maximize the number of vacation days you could take, but there are certain rules and restrictions you need to follow.
Rules and restrictions:
You can only travel among N cities, represented by indexes from 0 to N-1. Initially, you are in the city indexed 0 on Monday.
The cities are connected by flights. The flights are represented as a N*N matrix (not necessary symmetrical), called flightsrepresenting the airline status from the city i to the city j. If there is no flight from the city i to the city j, flights[i][j] = 0; Otherwise, flights[i][j] = 1. Also, flights[i][i] = 0 for all i.
You totally have K weeks (each week has 7 days) to travel. You can only take flights at most once per day and can only take flights on each week's Monday morning. Since flight time is so short, we don't consider the impact of flight time.
For each city, you can only have restricted vacation days in different weeks, given an N*K matrix called days representing this relationship. For the value of days[i][j], it represents the maximum days you could take vacation in the city i in the week j.
You're given the flights matrix and days matrix, and you need to output the maximum vacation days you could take during K weeks.
Example 1:
Input:flights = [[0,1,1],[1,0,1],[1,1,0]], days = [[1,3,1],[6,0,3],[3,3,3]]
Output: 12
Explanation:
Ans = 6 + 3 + 3 = 12.

One of the best strategies is:
1st week : fly from city 0 to city 1 on Monday, and play 6 days and work 1 day.
(Although you start at city 0, we could also fly to and start at other cities since it is Monday.) 
2nd week : fly from city 1 to city 2 on Monday, and play 3 days and work 4 days.
3rd week : stay at city 2, and play 3 days and work 4 days.


Example 2:
Input:flights = [[0,0,0],[0,0,0],[0,0,0]], days = [[1,1,1],[7,7,7],[7,7,7]]
Output: 3
Explanation:
Ans = 1 + 1 + 1 = 3.

Since there is no flights enable you to move to another city, you have to stay at city 0 for the whole 3 weeks.
For each week, you only have one day to play and six days to work.
So the maximum number of vacation days is 3.

Example 3:
Input:flights = [[0,1,1],[1,0,1],[1,1,0]], days = [[7,0,0],[0,7,0],[0,0,7]]
Output: 21
Explanation:
Ans = 7 + 7 + 7 = 21

One of the best strategies is:
1st week : stay at city 0, and play 7 days. 
2nd week : fly from city 0 to city 1 on Monday, and play 7 days.
3rd week : fly from city 1 to city 2 on Monday, and play 7 days.


Note:
N and K are positive integers, which are in the range of [1, 100].
In the matrix flights, all the values are integers in the range of [0, 1].
In the matrix days, all the values are integers in the range [0, 7].
You could stay at a city beyond the number of vacation days, but you should work on the extra days, which won't be counted as vacation days.
If you fly from the city A to the city B and take the vacation on that day, the deduction towards vacation days will count towards the vacation days of city B in that week.
We don't consider the impact of flight hours towards the calculation of vacation days.
例子:
    A   B   C
A  0   1   1
B  1   0   1
C  1   1   0

    W1   W2   W3
A  1      3       1 
B  6      0       3
C  3      3       3
度假策略:
第一周在城市b+第二周在城市a+第三周在城市c = 12

还有别的选择:
第一周在城市b+第二周在城市c+第三周在城市c = 12 => 可以,也是最大
第一周在城市a+第二周在城市c+第三周在城市b = 7 =>没有maximize 假期

飞行策略:
1st week: 星期一从城市A飞到城市b, 玩6天工作1天
2nd week: 星期一从城市b飞到城市a, 玩3天工作4天
3rd week: 星期一从城市a飞到城市c, 玩3天工作4天

规则:
flight[i][j] = 0 代表i 和j之间的城市不能飞, = 1代表能飞
每天只能飞一次。而且只能每周一早上飞。飞行时间忽略不算
days[i][j] 代表在week j,城市i, 最多能都take vacations的天数


思路:
构图:


Vertex: 城市+ 休假天数
Neighbors:  下个星期可以飞到的node (flights[i][j] == 1或者也可以停留在自己的城市)


Solution 1:
Brute Force:
生成所有可能的方案,并且从中选择最优的方案。
所有可能的方案: 枚举不同的星期选择不同的城市

levels: weeks
branch: 城市
Time: O(n^k)
Space: O(k) where n is the number of cities and k is the number of weeks

Solution 2:
DFS + Memorization

Memorization:
Memo[i][j] = 在城市i, 和 week j 的最大假期天数
Time: O(n*k*n)
Space: O(n*k) -- where n is the number of cities and k is the number of weeks



public int maxVacationDays(int[][] flights, int[][] days) {
        if (flights == null || flights.length == 0 || days == null || days.length == 0) return 0;
        int[][] memo = new int[flights.length][days[0].length];
        return getMaxDays(flights, days, memo, 0, 0);
    }
    
    private int getMaxDays(int[][] flights, int[][] days, int[][] memo, int city, int week) {
        if (week == days[0].length)  return 0;
        if (memo[city][week] != 0) return memo[city][week];
        int maxDays = 0;
        for (int i = 0; i < flights.length; i++) {
            if (city == i || flights[city][i] == 1) {
                maxDays = Math.max(maxDays, getMaxDays(flights, days, memo, i, week + 1) + days[i][week]);
            }
        }
        memo[city][week] = maxDays;
        return maxDays;
  } 


Solution 3:
state: dp[i][j] -- the max vacation days in city i in the week j
induction rule: 
dp[i][j] = Math.max(dp[x][j - 1]) + days[i][j] for x == i || city[i] and city[x] have direct flight
Base Case:
dp[i][0] = days[i][0] 每个城市第0个星期的vacation days
result: Math.max(dp[i][K]) 所有城市中第k个星期days的最大值

Time: O(n*k*n)
Space: O(n*k) -- where n is the number of cities and k is the number of weeks


public int maxVacationDays(int[][] flights, int[][] days) {
        if (flights == null || flights.length == 0 || days == null || days.length == 0) return 0;
        int N = flights.length;
        int K = days[0].length;
        int[][] dp = new int[N][K];
        
        for (int j = 0; j < K; j++) {
            for (int i = 0; i < N; i++) {
                dp[i][j] = -1;
                if (j == 0) {
                    if (i == 0 || flights[0][i] == 1) {
                        dp[i][0] = days[i][0];
                    }
                } else {
                    for (int k = 0; k < N; k++) {
                        if (dp[k][j - 1] != -1 && (k == i || flights[k][i] == 1)) {
                            dp[i][j] = Math.max(dp[i][j], dp[k][j - 1] + days[i][j]);
                        }
                    }
                }
                
            }
        }
        int res = 0;
        for (int i = 0; i < N; i++) {
            res = Math.max(res, dp[i][K - 1]);
        }
        
        return res;
    }

Solution 4:
问题转化=> 最多能歇几天, 最少工作几天

 

标签
易学教程内所有资源均来自网络或用户发布的内容,如有违反法律规定的内容欢迎反馈
该文章没有解决你所遇到的问题?点击提问,说说你的问题,让更多的人一起探讨吧!